=== debian/changelog ===
sather (1.2.pre4-1) unstable; urgency=low

  * New upstream version

 -- Norbert Nemec <nobbi@gnu.org>  Tue, 14 Sept 1999 15:21:50 +0200

sather (1.2-1) unstable; urgency=low

  * New upstream version ( Working towards GNU Sather )

 -- Norbert Nemec <nobbi@gnu.org>  Sun, 25 Jul 1999 16:21:50 +0200

sather (1.2b-2) unstable; urgency=low

  * Fixing stuff up to get first preliminary version out.

 -- Norbert Nemec <nobbi@gnu.org>  Thu, 20 May 1999 22:43:08 +0200

sather (1.2b-1) unstable; urgency=low

  * Removed GC from package, now depends on libgc4
  * Initial Release.

 -- Norbert Nemec <nobbi@gnu.org>  Tue,  23 Feb 1999 13:07:50 +0100

Local variables:
mode: debian-changelog
add-log-mailing-address: "nobbi@gnu.org"
End:
